﻿using UnityEngine;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bob's Broom - BM",
                    DescriptionOverride = "Its Bob's Broom! Handle with care.",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/broomView.png"),
                    AfterSpawn = (Instance) =>
                    {
						foreach (Collider2D col in Instance.GetComponents<Collider2D>()) GameObject.Destroy(col);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/handleCol.png",10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/broomCol.png",10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Broom.png");
                        Instance.AddComponent<SoapBehaviour>();
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bob's Mop - BM",
                    DescriptionOverride = "Its Bob's Mop! For blood and stuff...",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/mopView.png"),
                    AfterSpawn = (Instance) =>
                    {
						foreach (Collider2D col in Instance.GetComponents<Collider2D>()) GameObject.Destroy(col);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/mophandleCol.png",10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/mopCol.png",10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/mop.png");
                        Instance.AddComponent<SoapBehaviour>();
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bob's Cone - BM",
                    DescriptionOverride = "Its Bob's Favorite thing! It saved his life!",
                    CategoryOverride = ModAPI.FindCategory("Misc"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/bobconeView.png"),
                    AfterSpawn = (Instance) =>
                    {
			    		Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/coneleftCollider.png", 10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/conerightCollider.png", 10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/bobcone.png");
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
                    }
                }
            );
			
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bob's Hand - BM",
                    DescriptionOverride = "Its Bob's hand! Or arm... doesnt matter. Connect to his head by invisible wire!",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/bobhandView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/bobhand.png");
                        Instance.AddComponent<LimbBehaviour>();
						Instance.FixColliders();
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                    }	
			    }
            );
			
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bob's Head - BM",
                    DescriptionOverride = "Its Bob's head! Or body... doesnt matter. Use blood wires for eyes/mouth!",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/bobheadView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/bobhead.png");
                        Instance.AddComponent<LimbBehaviour>();
						Instance.FixColliders();
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                    }
			    }
            );
		
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Spray Bottle - BM",
                    DescriptionOverride = "For cleaning!",
                    CategoryOverride = ModAPI.FindCategory("Misc"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/spraybottleView.png"),
                    AfterSpawn = (Instance) =>
                    {
						foreach (Collider2D col in Instance.GetComponents<Collider2D>()) GameObject.Destroy(col);
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/bottleCol.png", 20);
                        Instance.AddComponent<PolygonCollider2D>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/sprayCol.png", 20);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/spraybottle.png", 20);
						Instance.AddComponent<FlaskBehaviour>();
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
                    }
			    }
            );
			
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soap"),
                    NameOverride = "Sponge - BM",
                    DescriptionOverride = "Who lives in the pineapple under the sea? BOB THE JANITOR!",
                    CategoryOverride = ModAPI.FindCategory("Misc"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/spongeView.png"),
                    AfterSpawn = (Instance) =>
                    {
						Instance.FixColliders();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/sponge.png");
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
			        }		
				}
            );
						
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soap"),
                    NameOverride = "Brush - BM",
                    DescriptionOverride = "It's like a broom, But smaller!",
                    CategoryOverride = ModAPI.FindCategory("Misc"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/brushView.png"),
                    AfterSpawn = (Instance) =>
                    {
						foreach (Collider2D col in Instance.GetComponents<Collider2D>()) GameObject.Destroy(col);
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/brushCol.png", 10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/brush.png");
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
			        }		
				}
            );
									
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soap"),
                    NameOverride = "Roomba - BM",
                    DescriptionOverride = "Tabby! (He will clean your floor)",
                    CategoryOverride = ModAPI.FindCategory("Misc"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/roombaView.png"),
                    AfterSpawn = (Instance) =>
                    {
						foreach (Collider2D col in Instance.GetComponents<Collider2D>()) GameObject.Destroy(col);
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/roombaCol.png", 10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/roomba.png");
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Ice");
			        }		
				}
            );
												
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Janitor's Bucket - BM",
                    DescriptionOverride = "For your mop!",
                    CategoryOverride = ModAPI.FindCategory("Misc"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/bucketView.png"),
                    AfterSpawn = (Instance) =>
                    {
						foreach (Collider2D col in Instance.GetComponents<Collider2D>()) GameObject.Destroy(col);
			    		Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/bucketCol.png", 10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/bucket.png", 10);
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
			        }		
				}
            );
															
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Tinfoil Hat - BM",
                    DescriptionOverride = "For Borb!",
                    CategoryOverride = ModAPI.FindCategory("Misc"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/borbhatView.png"),
                    AfterSpawn = (Instance) =>
                    {
						foreach (Collider2D col in Instance.GetComponents<Collider2D>()) GameObject.Destroy(col);
			    		Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/coneleftCollider.png", 10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/conerightCollider.png", 10);
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/borbhat.png");
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
			        }		
				}
            );
																		
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Jug - BM",
                    DescriptionOverride = "For holding liquids!",
                    CategoryOverride = ModAPI.FindCategory("Misc"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/liquidcontainerView.png"),
                    AfterSpawn = (Instance) =>
                    {
						foreach (Collider2D col in Instance.GetComponents<Collider2D>()) GameObject.Destroy(col);
						Instance.AddComponent<FlaskBehaviour>();
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/jugCol.png", 10);
                        Instance.AddComponent<PolygonCollider2D>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/jug.png", 10);
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Plastic");
			        }		
				}
            );
			
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), 
					NameOverride = "Cleaning Bot - BM", 
					DescriptionOverride = "Subsisto!",
					CategoryOverride = ModAPI.FindCategory("Entities"), 
					ThumbnailOverride = ModAPI.LoadSprite("thumbnails/subsistobotView.png"),
					AfterSpawn = (Instance) =>
					{
						var skin = ModAPI.LoadTexture("npcs/subsistobot.png");

						var person = Instance.GetComponent<PersonBehaviour>();

						person.SetBodyTextures(skin, null, null, 1);

					}
			    }
			);
						
			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), 
					NameOverride = "Cleaning Bot 2 - BM", 
					DescriptionOverride = "EChrizzy!",
					CategoryOverride = ModAPI.FindCategory("Entities"), 
					ThumbnailOverride = ModAPI.LoadSprite("thumbnails/bot2View.png"),
					AfterSpawn = (Instance) =>
					{
						var skin = ModAPI.LoadTexture("npcs/ChrizzyBot.png");

						var person = Instance.GetComponent<PersonBehaviour>();

						person.SetBodyTextures(skin, null, null, 1);

					}
			    }
			);
									
			ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Simon The Snail - BM",
                    DescriptionOverride = "Simon!",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/simonView.png"),
                    AfterSpawn = (Instance) =>
                    {
						foreach (Collider2D col in Instance.GetComponents<Collider2D>()) GameObject.Destroy(col);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("colliders/simonCol.png", 20);
                        Instance.AddComponent<PolygonCollider2D>();
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/simon.png", 2);
						Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
					}
			    }
			);
        }
    }
}